MPI_Comm_get_attr(3)

NAME
MPI_Comm_get_attr - Retrieves attribute value by key

SYNOPSIS
int MPI_Comm_get_attr(MPI_Comm comm, int comm_keyval, void *attribute_val,
int *flag)

INPUT PARAMETERS
comm
    - communicator to which the attribute is attached (handle)
comm_keyval
    - key value (integer)

OUTPUT PARAMETERS
attribute_val
    - attribute value, unless flag = false (None)
flag
    - false if no attribute is associated with the key (logical)

NOTES
Attributes must be extracted from the same language as they were inserted in with MPI_ATTR_PUT . The notes for C and Fortran below explain why.

THREAD AND INTERRUPT SAFETY
This routine is thread-safe. This means that this routine may be safely used by multiple threads without the need for any user-provided thread locks. However, the routine is not interrupt safe. Typically, this is due to the use of memory allocation routines such as malloc or other non-MPICH runtime routines that are themselves not interrupt-safe.

NOTES FOR C
Even though the attribute_val argument is declared as void * , it is really the address of a void pointer (i.e., a void ** ). Using a void * , however, is more in keeping with C idiom and allows the pointer to be passed without additional casts.

NOTES FOR FORTRAN
All MPI routines in Fortran (except for MPI_WTIME and MPI_WTICK ) have an additional argument ierr at the end of the argument list. ierr is an integer and has the same meaning as the return value of the routine in C. In Fortran, MPI routines are subroutines, and are invoked with the call statement. All MPI objects (e.g., MPI_Datatype , MPI_Comm ) are of type INTEGER in Fortran. The attribute_val in Fortran is a pointer to a Fortran integer, not a pointer to a void * .

ERRORS
All MPI routines (except MPI_Wtime and MPI_Wtick ) return an error value; C routines as the value of the function and Fortran routines in the last argument. Before the value is returned, the current MPI error handler is called. By default, this error handler aborts the MPI job. The error handler may be changed with MPI_Comm_set_errhandler (for communicators), MPI_File_set_errhandler (for files), and MPI_Win_set_errhandler (for RMA windows). The MPI-1 routine MPI_Errhandler_set may be used but its use is deprecated. The predefined error handler MPI_ERRORS_RETURN may be used to cause error values to be returned. Note that MPI does not guarantee that an MPI program can continue past an error; however, MPI implementations will attempt to continue whenever possible.
MPI_SUCCESS
    - No error; MPI routine completed successfully.
MPI_ERR_ARG
    - Invalid argument. Some argument is invalid and is not identified by a specific error class (e.g., MPI_ERR_RANK ).
MPI_ERR_COMM
    - Invalid communicator. A common error is to use a null communicator in a call (not even allowed in MPI_Comm_rank ).
MPI_ERR_KEYVAL
    - Invalid keyval
MPI_ERR_OTHER
    - Other error; use MPI_Error_string to get more information about this error code.